

#include <iostream>

using namespace std;

struct frazione {
  int numeratore;
  int denominatore;
};

// individua se il numero intero n e' divisibile per l'intero d
bool e_divisibile(int n, int d)
{
    if ((n % d) == 0)
       return(true);
    else
       return(false);
};

// controlla la primalita' del numero n
bool e_primo(int n)
{
    int scan;
    bool primo;

    primo = true;
    for (scan = 2; scan < n; scan++)
        if ((n % scan) == 0)
        {
            primo = false;
            break;
        }

    return(primo);
};

// trova un primo successivo dato il precedente
int primo_succ(int np)
{
    int scan;

    scan = np + 1;
    while (! e_primo(scan))  scan++;

    return(scan);
};

int main()
{
     frazione fr1;
     int divis, n_minimo;

     // legge la frazione (eventualmente non ridotta)
     cout << "Assegna una frazione: (num den)  ";
     cin >> fr1.numeratore >> fr1.denominatore;

     // ciclo di riduzione del numeratore e denominatore
     // finche' il divisore raggiunge il minimo  tra numeratore e denominatore
     divis = 2;
     while (divis <= min(abs(fr1.numeratore), abs(fr1.denominatore)))
     {
          if ((e_divisibile(fr1.numeratore,divis)) &&
                (e_divisibile(fr1.denominatore,divis)))
         {
              fr1.numeratore = fr1.numeratore / divis;
              fr1.denominatore = fr1.denominatore / divis;
         }
         else
              divis = primo_succ(divis);
     }

     // output della frazione ridotta    
     cout << "La frazione ridotta risulta: " << fr1.numeratore <<
          "/" << fr1.denominatore;

     // se il denominatore e' 1 effettua anche una stampa alternativa      
     if (fr1.denominatore == 1)
        cout << "   vale a dire  " << fr1.numeratore << endl;
     else
        cout << endl;         

     system("PAUSE");        // aspetta un tasto per proseguire ed uscire

     return(0);
}
